//	MDI(Multiple Document Interface)Tv

#include <windows.h>
#include <tchar.h>
#include "resource.h"

#define IDM_FIRSTCHILD 100	//hLgEBhE̍ŏIDԍ@ȍ~I1Z


#ifdef _WIN64
	typedef LONG_PTR WINDOW_LONG_PTR;
#else
	typedef LONG WINDOW_LONG_PTR;
#endif

LRESULT CALLBACK FrameWndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK DocProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK CloseAllProc(HWND, LPARAM);
int MyRegisterWC(WNDPROC, LPCTSTR, HBRUSH);

TCHAR szFrameClassName[] = _TEXT("mdi_org");    //t[EBhENX
TCHAR szChildDoc[] = _TEXT("document_org"); //hLg

HMENU hMenuFirst, hMenuDoc;
HMENU hMenuFirstWnd, hMenuDocWnd;
HINSTANCE hInst;

int doc_no=0;	//	hLg(qEBhE)ԍ

int WINAPI _tWinMain(HINSTANCE hCurInst, HINSTANCE hPrevInst,
                   TCHAR* lpsCmdLine, int nCmdShow){
	MSG msg;
	HWND hFrame, hClient;

	::hInst = hCurInst;
//	t[EBhẼNX̓o^   
	if(!MyRegisterWC(FrameWndProc, szFrameClassName,(HBRUSH)(COLOR_APPWORKSPACE + 1)))
		return FALSE;
//	hLgEBhẼNX̓o^   
	if(!MyRegisterWC(DocProc, szChildDoc, (HBRUSH)GetStockObject(WHITE_BRUSH)))
		return FALSE;
//	t[EBhẼj[ǂݍ
	::hMenuFirst = LoadMenu(hInst, _TEXT("MYMENU"));
	::hMenuFirstWnd = GetSubMenu(hMenuFirst, 0);
//	hLgEBhẼj[ǂݍ
	::hMenuDoc = LoadMenu(hInst, _TEXT("MYDOCUMENT"));
	::hMenuDocWnd = GetSubMenu(hMenuDoc, 1);
//	t[EBhE̍쐬
	hFrame = CreateWindow(
		szFrameClassName,
		_TEXT("Multiple Document Interface"),	//	EBhE^Cg
		WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		NULL,
		::hMenuFirst,
		::hInst,
		NULL);
	hClient = GetWindow(hFrame, GW_CHILD);
	ShowWindow(hFrame, nCmdShow);
	UpdateWindow(hFrame);

	while (GetMessage(&msg, NULL, 0, 0)) {
		if (!TranslateMDISysAccel(hClient, &msg)) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	DestroyMenu(hMenuDoc);
	return int(msg.wParam);
}

//	t[EBhẼvV[W[

LRESULT CALLBACK FrameWndProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp){
	static HWND hClient;
	HWND hChild;
	switch (msg) {
		case WM_CREATE:{
			// NCAgEBhE̍쐬
			CLIENTCREATESTRUCT ccs;
			ccs.hWindowMenu = hMenuFirstWnd;
			ccs.idFirstChild = IDM_FIRSTCHILD;//hLgEBhE̍ŏIDԍ
			hClient = CreateWindow(
			_TEXT("MDICLIENT"),
			NULL,
			WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN,
			0, 0, 0, 0,
			hWnd,
			(HMENU)1,
			::hInst,
			(LPSTR)&ccs);
			return 0;
		}
		case WM_COMMAND:
			switch (LOWORD(wp)) {
				case IDM_NEW:{	//	VK쐬j[I qEBhE̍쐬
					MDICREATESTRUCT mdic;
					TCHAR str[64];

					wsprintf(str, _TEXT("eLXg %d"), ::doc_no);
					TCHAR* text=_tcsdup(str);

					wsprintf(str, _TEXT("DOCUMENT[%d]"), ::doc_no);
					mdic.szClass = szChildDoc;
					mdic.szTitle = str;
					mdic.hOwner = ::hInst;
					mdic.x = CW_USEDEFAULT;
					mdic.y = CW_USEDEFAULT;
					mdic.cx = CW_USEDEFAULT;
					mdic.cy = CW_USEDEFAULT;
					mdic.style = 0;
					mdic.lParam = (LPARAM)text; //hLgEBhE쐬ɓnp[^
					hChild = (HWND)SendMessage(hClient, WM_MDICREATE, 0,
					(LPARAM)&mdic);
					++ ::doc_no;
					return 0;
				}
				case IDM_CLOSE:	//	ANeBuȃhLgEBhE
					hChild = (HWND)SendMessage(hClient, WM_MDIGETACTIVE, 0, 0);
					if (hChild)
						SendMessage(hClient, WM_MDIDESTROY, (WPARAM)hChild, 0);
					return 0;
				case IDM_EXIT:	//	vOI
					SendMessage(hWnd, WM_CLOSE, 0, 0);
					return 0;
				case IDM_CLOSEALL:	//	SẴhLgEBhE
					EnumChildWindows(hClient, &CloseAllProc, 0);
					return 0;
				case IDM_TILE:	//	hLgEBhEׂĕ\
					SendMessage(hClient, WM_MDITILE, 0, 0);
					return 0;
				case IDM_CASCADE:	//	hLgEBhEd˂ĕ\
					SendMessage(hClient, WM_MDICASCADE, 0, 0);
					return 0;
				case IDM_ARRANGE:	//	ACR̐(ŏꂽhLgEBhẼACR𐮗)
					SendMessage(hClient, WM_MDIICONARRANGE, 0, 0);
					return 0;
				default:
					hChild = (HWND)SendMessage(hClient, WM_MDIGETACTIVE, 0, 0);
					if (IsWindow(hChild))
						SendMessage(hChild, WM_COMMAND, wp, lp);
					break;
			}
			break;
		case WM_CLOSE:	//	t[EBhȄIɌĂяoB
			SendMessage(hWnd, WM_COMMAND, IDM_CLOSEALL, 0);
			if (GetWindow(hClient, GW_CHILD))
				return 0;
			break;
		case WM_DESTROY:
			PostQuitMessage(0);
			return 0;
	}
	return DefFrameProc(hWnd, hClient, msg, wp, lp);
}

// hLgEBhẼvV[W[

LRESULT CALLBACK DocProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp){
	static HWND hClient, hFrame;
	TCHAR* str;

	switch (msg) {
		case WM_CREATE:{
			hClient = GetParent(hWnd);
			hFrame = GetParent(hClient);
			LPCREATESTRUCT lpcs=(LPCREATESTRUCT)lp;
			LPMDICREATESTRUCT lpmdis=(LPMDICREATESTRUCT)lpcs->lpCreateParams;

			str=(TCHAR*)lpmdis->lParam;	//	qEBhE쐬Ɏw肳ꂽp[^擾
			// eEBhEƂɌʂɎgpł郁Ƀt[EBhEnꂽۑ
			SetWindowLongPtr(hWnd, GWLP_USERDATA, (WINDOW_LONG_PTR)str); 
			return 0;
		}
		case WM_PAINT:{
			PAINTSTRUCT ps;
			HDC hdc=BeginPaint(hWnd,&ps); 
			// eEBhEƂɌʂɎgpł郁當擾
			str=(TCHAR*)GetWindowLongPtr(hWnd, GWLP_USERDATA);
			TextOut(hdc,0,0,str,int(_tcslen(str)));
			EndPaint(hWnd,&ps); 
			break;
		}
		case WM_SIZE:
			break;
		case WM_MDIACTIVATE:
			if (lp == (LPARAM)hWnd)
				SendMessage(hClient, WM_MDISETMENU, (WPARAM)::hMenuDoc, (LPARAM)::hMenuDocWnd);
			else
				SendMessage(hClient, WM_MDISETMENU, (WPARAM)::hMenuFirst, (LPARAM)::hMenuFirstWnd);
			DrawMenuBar(hFrame);
			return 0;
	}
	return (DefMDIChildProc(hWnd, msg, wp, lp));
}

//	w肷MDIhLgEBhE(EnumChildWindowsĂяo)

BOOL CALLBACK CloseAllProc(HWND hWnd, LPARAM lp){
	SendMessage(GetParent(hWnd), WM_MDIDESTROY, (WPARAM)hWnd, 0);
	return TRUE;
}

//	EBhENXo^

int MyRegisterWC(WNDPROC lpfnWndProc, LPCTSTR lpszClassName, HBRUSH hbrBack){
	WNDCLASSEX wc;

	wc.cbSize = sizeof(WNDCLASSEX);
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = lpfnWndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInst;        //CX^X
	wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = hbrBack;
	wc.lpszMenuName = NULL;    //j[
	wc.lpszClassName = lpszClassName;
	wc.hIconSm = LoadIcon(NULL, IDI_APPLICATION);
	return(RegisterClassEx(&wc));
}
